Subject: Re: [PATCH] iproute2: fix build failure on ppc64le

From: Stephen Hemminger <[email-masked]>
Date: Wed, 14 Feb 2024 19:05:19 -0800

On Wed, 14 Feb 2024 08:49:02 -0700
David Ahern <[email-masked]> wrote:

> On 2/14/24 8:30 AM, Andrea Claudi wrote:
> > On Fri, Feb 09, 2024 at 04:45:42PM -0800, Stephen Hemminger wrote:  
> >> On Fri, 9 Feb 2024 15:14:28 -0700
> >> David Ahern <[email-masked]> wrote:
> >>  
> >>> On 2/9/24 9:35 AM, Stephen Hemminger wrote:  
> >>>> On Fri,  9 Feb 2024 11:24:47 +0100
> >>>> Andrea Claudi <[email-masked]> wrote:
> >>>>     
> >>>>> ss.c:3244:34: warning: format ‘%llu’ expects argument of type ‘long long unsigned int’, but argument 2 has type ‘__u64’ {aka ‘long unsigned int’} [-Wformat=]
> >>>>>  3244 |                 out(" rcv_nxt:%llu", s->mptcpi_rcv_nxt);
> >>>>>       |                               ~~~^   ~~~~~~~~~~~~~~~~~
> >>>>>       |                                  |    |
> >>>>>       |                                  |    __u64 {aka long unsigned int}
> >>>>>       |                                  long long unsigned int
> >>>>>       |                               %lu
> >>>>>
> >>>>> This happens because __u64 is defined as long unsigned on ppc64le.  As
> >>>>> pointed out by Florian Weimar, we should use -D__SANE_USERSPACE_TYPES__
> >>>>> if we really want to use long long unsigned in iproute2.    
> >>>>
> >>>> Ok, this looks good.
> >>>> Another way to fix would be to use the macros defined in inttypes.h
> >>>>
> >>>> 		out(" rcv_nxt:"PRIu64, s->mptcpi_rcv_nxt);
> >>>>     
> >>>
> >>> since the uapi is __u64, I think this is the better approach.  
> >>
> >> NVM
> >> Tried it, but __u64 is not the same as uint64_t even on x86.
> >> __u64 is long long unsigned int
> >> uint64_t is long unsigned int
> >>  
> > 
> > Is there anything more I can do about this?
> >   
> 
> where does the uint64_t come in? include/uapi/linux/mptcp.h has
> mptcpi_rcv_nxt as __u64 and PRIu64 macros should be working without a
> problem - this is what perf tool uses consistently.

I just did this:

diff --git a/misc/ss.c b/misc/ss.c
index 5296cabe9982..679d50b8fef6 100644
--- a/misc/ss.c
+++ b/misc/ss.c
@@ -8,6 +8,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
+#include <inttypes.h>
 #include <fcntl.h>
 #include <sys/ioctl.h>
 #include <sys/socket.h>
@@ -3241,7 +3242,7 @@ static void mptcp_stats_print(struct mptcp_info *s)
        if (s->mptcpi_snd_una)
                out(" snd_una:%llu", s->mptcpi_snd_una);
        if (s->mptcpi_rcv_nxt)
-               out(" rcv_nxt:%llu", s->mptcpi_rcv_nxt);
+               out(" rcv_nxt:%" PRIu64, s->mptcpi_rcv_nxt);
        if (s->mptcpi_local_addr_used)
                out(" local_addr_used:%u", s->mptcpi_local_addr_used);
        if (s->mptcpi_local_addr_max)

And got this:
    CC       ss.o
ss.c: In function ‘mptcp_stats_print’:
ss.c:3245:21: warning: format ‘%lu’ expects argument of type ‘long unsigned int’, but argument 2 has type ‘__u64’ {aka ‘long long unsigned int’} [-Wformat=]
 3245 |                 out(" rcv_nxt:%" PRIu64, s->mptcpi_rcv_nxt);
      |                     ^~~~~~~~~~~~         ~~~~~~~~~~~~~~~~~
      |                                           |
      |                                           __u64 {aka long long unsigned int}
In file included from ss.c:11:
/usr/include/inttypes.h:105:41: note: format string is defined here
  105 | # define PRIu64         __PRI64_PREFIX "u"